from pytest import approx

try:
    import uke_06_oppg_1 as M
except ModuleNotFoundError:
    import oppgaver.uke_06_oppg_1 as M


############## remove_fives() ##############
def test_1_1():  # sample from text
    assert M.remove_fives([0, 5, 95, 25, 50, 7, 20, 11]) == [0, 95, 25, 50, 7, 20, 11]


def test_1_2():  # x.5 is fine
    assert M.remove_fives([3.2, 5.6, 0.7, 2]) == approx([
        3.2, 5.6, 0.7, 2,
    ])


def test_1_3():  # with strings
    assert M.remove_fives(["bird", "cat", 5, "dog"]) == ["bird", "cat", "dog"]


def test_1_4():  # begin and end list with 5
    assert M.remove_fives([5, 0, 5, 7, 5, 23, 5]) == [0, 7, 23]


def test_1_5():  # 5s next to each other
    assert M.remove_fives([5, 5, 5]) == []


def test_1_6():  # make empty
    assert M.remove_fives([5]) == []


############## every_other() ##############
def test_2_1():  # sample from text
    assert M.every_third(["a", 1, "b", "c", 2, 6, "g", 4, "p", "q"]) == [
        "a",
        "c",
        "g",
        "q",
    ]


def test_2_2():  
    assert M.every_third([1, 2, 3, 4, 3]) == [1, 4]


def test_2_3():  
    assert M.every_third(
        ["cat", "dog", "horse", "pig", "mouse", "moose", "fox", "goat", "sheep"]
    ) == ["cat", "pig", "fox"]


############## reverse() ##############
def test_3_1():  # sample from text
    assert M.reverse([5, 6, 7, 8, 9, 10]) == [10, 9, 8, 7, 6, 5]


def test_3_2():
    assert M.reverse(["cat", "dog", "horse"]) == ["horse", "dog", "cat"]


def test_3_3():
    assert M.reverse([1]) == [1]


############## halve_values() ##############
def test_4_1():  # sample from text
    assert M.halve_values([1, 2, 3, 4]) == approx([
        0.5, 1.0, 1.5, 2.0,
    ])


def test_4_2(): 
    assert M.halve_values([10000, 500, 4]) == [5000, 250, 2]


def test_4_3(): 
    assert M.halve_values([0, 1.2]) == [0, approx(0.6)]


############## unique_values() ##############
def test_5_1():  # sample from text
    assert M.unique_values([3, 1, 6, 10, 30, 30, 30, 3, 0, 6]) == [3, 1, 6, 10, 30, 0]


def test_5_2():  # not cap sensitive
    assert M.unique_values(["dog", "Dog", "cat"]) == ["dog", "Dog", "cat"]


def test_5_3():  # already all unique
    assert M.unique_values([0, 1, 2, 3, 4, 5]) == [0, 1, 2, 3, 4, 5]


def test_5_4():
    assert M.unique_values([1, 1, 1]) == [1]


def test_5_5():
    assert M.unique_values([1]) == [1]


############## my_len() ##############


def test_6_1():
    assert M.my_len([1, 2, 3, 4, 5]) == len([1, 2, 3, 4, 5])


def test_6_2():
    assert M.my_len([]) == len([])


def test_6_3():
    assert M.my_len([3, 1, 6, 10, 30, 30, 30, 3, 0, 6]) == len(
        [3, 1, 6, 10, 30, 30, 30, 3, 0, 6]
    )


def test_6_4():
    assert M.my_len("platypus") == len("platypus")


def test_6_2():
    assert M.my_len(["123"]) == len(["123"])
